#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Thu Jun 22 08:01:08 2017

@author: thiago
"""



def fix_heap_down(a, inicio, fim):
    pai = inicio
    esquerdo = 2*pai + 1
    while esquerdo < fim:
        direito = esquerdo + 1
        if direito < fim and a[direito]>a[esquerdo]:
            maior = direito
        else:
            maior = esquerdo
        if a[pai] < a[maior]:
            a[pai], a[maior] = a[maior], a[pai]
        else:
            break     
        pai = maior
        esquerdo = 2*pai + 1
        
def fix_heap_up(a, fim):
    filho = fim-1
    pai = (filho - 1)//2
    while pai >= 0:
        if a[pai] < a[filho]:
            a[pai], a[filho] = a[filho], a[pai]
        else:
            break
        filho = pai
        pai = (filho - 1)//2

def monta_heap_old(a, fim):
    fim_heap = 0
    while fim_heap < fim:
        fim_heap += 1
        fix_heap_up(a, fim_heap)

def monta_heap(a, fim):
    pai = (fim - 1)//2
    while pai >= 0:
        fix_heap_down(a, pai, fim)
        pai -= 1

def heapsort(a):
    ultimo = len(a)      
    monta_heap(a, ultimo)
    ultimo -= 1
    while ultimo > 0:
        a[0], a[ultimo] = a[ultimo], a[0]
        fix_heap_down(a, 0, ultimo)
        ultimo -= 1
        
        
    
        